\noindent The~performance of the~Ethernet \as{l2} switch depends significantly on the~design of the~MAC lookup table and the~table search algorithm, as outlined in chapter \ref{background}. Although \as{ieee}~802.1Q standard defines the~Filtering Database object along with the~types and parameters of its entries and the~management operations that can be performed on the~database, its implementation is entirely project-specific. Primarily, the~filtering process could be implemented in a~\as{cpu} only with the~database resided in a~computer's main memory. However, as network bandwidth and switch complexity increase, the~time allotted to process a~frame decreases to the~point where a~software-only approach is inefficient, and hardware implementation usually is a~necessity. 

This chapter contains the~review of the~literature related to the~Filtering Database and a~forwarding engine designs with a~focus on state-of-the-art solutions amenable to \as{fpga} implementation as it is the~target platform in the~\al{wrs} project.

\section{Filtering Database Implementation Criteria}
\label{implementation-criteria}

\noindent Numerous criteria~should be considered when selecting the~appropriate Filtering Database implementation as it is based on individual project requirements and available technology. The~categories listed below describe the~aspects that have been considered within the~related work analysis, which is the~groundwork for a~target architecture choice.

\subsection{Required Lookup Table Size}
\label{required-lookup-table-size}

\noindent The~minimal required memory size for storing a~forwarding table can be estimated by multiplying a~single entry length by the~number of entries in the~table. A~single entry consists of the~searching key -- a~\as{mac} address and \al{vid} / \al{fid} -- and the~associated information, which is at least a~port map. The~switch forwarding table may be designed to contain a~very different number of entries, depending on the~forecasted maximum number of nodes in the~network -- from a~few hundred to hundreds of thousands in the~case of data~centre switches\footnote{The~\as{mac} table capacity of data~centre switches is determined on the~basis of products' datasheets analysis: \url{https://www.arubanetworks.com/products/switches/core-and-data-center}, accessed \today, \\\url{https://www.fs.com/de-en/c/data-center-switches-3404}, accessed \today.}. Assuming the~size of the~single entry is between 16 and 32 bytes and the~average capacity of a~MAC lookup table in commercial \as{l2} switches is between 1K and 10K records~\cite[p. 196]{all-switch}\cite{effect}, the~most typical required memory size does not exceed an~MB.

Optimal network performance can be ensured only if switches incorporate tables with a~capacity large enough to accommodate all active addresses in the~network. Otherwise, regardless of whether new addresses will be ignored or the~current ones will be removed from the~table, some entries will be lost. Subsequent frames delivered to those lost \as{mac} address destinations will cause traffic flooding on all ports and thereby will severely degrade the~switch performance. 

% NOTE
% counter measures
% sposob na~MAC flooding - ograniczenie liczby MAC adresow, jakie moga byc "nauczone" (zapamietane) pochodzac z jednego portu

It should be emphasized that the~required memory size also depends on the~forwarding table structure. Particularly in hash-based solutions (discussed in section \ref{hash-based}), the~effective maximum table load may be prominently lower than the~size of the~table. 
% NOTE mlipinski
% ML: I do not understand what you mean by "max table load" and what is the significance of this paragraph...
% MZA: For instance, assuming that hash table is supposed to hold 10K MAC entries (table load), there must be reserved >10K slots in memory (size of the table). The probabilities of collisions and the size of the table that should be chosen are analyzed in "Filtering Table - Implementation". Some MAC tables implementations, like the simplest linear search, require exactly the same number of slots in memory as the number of MAC entries supposed to be hold. Thus, the overall size of the table in memory depends not only on the expected number of MAC entries, but also on the chosen forwarding table structure.

\subsection{Network Traffic Load}
\label{network-traffic-load}

\noindent The~maximum possible network traffic load of a~switch is a~result of the~number of its ports and their bandwidth. These factors affect satisfying the~following criteria, which are used to determine if a~switch is non-blocking and capable of operating at wire-speed: 
\begin{itemize}
	\item the~architecture of the~switch fabrics that allows buffering and handling all the~port bandwidths, at the~same time, at full capacity;
	\item the~ability to perform lookups and make forwarding decisions for a~maximum possible number of requests per second.
\end{itemize}

Depending on the~design, either data~flow capacity or table lookup may be the~main switch performance bottleneck. This chapter refers only to the~challenges related to the~required forwarding engine throughput. 

From the~lookup processing perspective, the~highest stress condition is when minimum-length Ethernet frames with a~minimum interframe gap are being received simultaneously on all the~ports. For instance, for 24 ports with a~10 Gb/s link, the~switch is supposed to handle up to 360 \af{mpps} (assuming full-duplex mode). In other words, a~new request for the~forwarding engine may be received every 2.8 ns. In the~case of the~centralized lookup architecture, even with full pipelining and, thus, the~ability of the~engine to accept the~subsequent requests in every clock cycle, the~required operating frequency is challenging.

If a~single forwarding engine is incapable of keeping up with the~requests rate, it is usually necessary to multiply the~engines and, as a~consequence, to increase the~utilized memory resources. Besides, a distributed lookup architecture entails the~problem of the~delays and overheads resulting from the~synchronization of the~contents of the~Filtering Database. The~proper synchronization is essential for the~lookup engines to operate in a~coherent manner. On the~other hand, such an~approach provides better performance and scalability.

\subsection{Upper-Bound Latency}
\label{upper-bound-latency}

\noindent Industry-accepted methods of benchmarking a~switch, including its latency, are defined by \as{rfc}~2544 specification~\cite{rfc2544}. However, to put it simply, a~latency introduced by a~switch may generally be understood as the~delay between a~start of receiving and transmitting a~given frame.

Most often, this latency is not a~substantial issue as the~majority of higher-layer protocols and applications do not care about delays on the~order of a~few milliseconds. For example, a~\as{tcp} protocol provides a~receive window mechanism that allows single frames delays without the~overall throughput decrease, at least as long as the~window is larger than the~total round-trip delay of the~network. Nonetheless, in some latency-sensitive applications, such as real-time systems, there are specific requirements concerning upper-bound latency through a~network and a~single switch.

In general, there may be distinguished three factors that contribute to the~total delay added by a~switch, and the~last two are highly contingent on the~device design:
\begin{itemize}
	\item network traffic characteristics,
	\item queuing delay,
	\item processing delay.
\end{itemize}

The~unpredictable nature of the~network traffic results in a~latency variation which means that each frame suffers a~different degree of delay. For instance, at any given moment in time, a~switch may be processing frames received on a~few input ports that are supposed to be forwarded to the~same output port, which creates short-term congestion. If the~switch supports prioritizing different classes of traffic, frames with a~higher priority may preempt those with a~lower priority. Besides, in the~case of unknown or multicast destinations, a~single frame is forwarded to multiple output ports.

The~resulting delay also depends on the~switch fabric, which is responsible for efficient transferring frames among all of the~input and output ports of a~switch. Although the~details of buffering architecture are outside the~scope of this thesis, there should be mentioned the~design issues that notably influence the~queuing delay:
\begin{itemize}
	\item cut-through switching technology,
	\item methods of resolving head-of-line blocking,
	\item approach to processing the~frames with different priorities,
	\item speed differences between ports.
\end{itemize}

The~processing delay involves an~internal switch operation, particularly the~time needed to search associative information in a~lookup table. For store-and-forward switches, a~search time should be less than the~interval between the~end of the~Ethernet Frame header of the~shortest Ethernet frame and the~start of receiving the~next frame, which is 56~ns for a~10 Gb/s link. If cut-through switching technology is used, the~search time should be as short as possible, still no longer than 56~ns for a~10 Gb/s link to ensure line-speed. The~time of processing a~single request by a~forwarding engine is conditioned on the~search algorithm, the~latency of the~memory, which stores a~lookup table and the~number of required memory accesses. The~worst-case scenario usually appears when a~\as{mac} address is not found. The~deterministic worst time to search is especially relevant for real-time systems.

\subsection{Memory Type}
\label{memory-type}

\noindent Taking the~criteria~specified above into consideration, the~memory type used for storing a~lookup table becomes one of the~fundamental design choices. In addition to required memory bandwidth and latency, cost per bit and power consumption are also important factors. Besides, high memory reliability is required for the \as{wr}-based systems used at \as{cern} as only one control frame may be lost per year~\cite{lipinski}.

The~Filtering Database is still most commonly implemented in high-speed \af{ram}, external to the~forwarding engine itself. The~latency of the~external memory access often imposes using appropriate pipelining techniques to reach an~expected switch throughput. Additionally, in the~case of using off-chip memory, its bandwidth is limited by the~number of pins required on both engine and memory devices that are acceptable in terms of hardware design cost and complexity. Acceleration techniques such as \af{ddr} may be used to increase the~memory bandwidth. 

As silicon density and available embedded memory resources increase, the~Filtering Database located within a~programmable logic memory becomes more of a~present-day solution. Its primary advantages are a~low latency (which is usually decreased to one or two clock cycles) and virtually unlimited width of a~memory data~path -- 256, 512, or more bits rather than conventional 32 or 64 bits -- which effectively multiplies the~memory bandwidth.

Another alternative is to use a~content-addressable memory. Although it is marked by high cost per~bit and power consumption~\cite[p. 93]{all-switch}\cite{cam}, it solves the~problem of implementing key-value storage such as Filtering Database. This type of memory is described in more detail in section \ref{s:cam}. 

% TODO parallel vs sequential

% Although multiple memory banks that may be accessed in parallel allows for increasing the~throughput, 

%	make use of the~small but high bandwidth on-chip memory to improve the~lookup performance of an
%	off-chip hash table? 

% multiple parallel memory banks (requiring more pins and more power)

\section{Content-Addressable Memories}
\label{s:cam}

\noindent \Af{cam} is a~specialized type of high-speed memory that compares input search data~against its entire content in a~single clock cycle and returns the~address of matching data. Thus, a~\as{cam} is a~hardware equivalent of an~associative array. Binary \as{cam} is the~simplest type of content-addressable memory and may search only for words consisting of bits with defined value: 0 or 1. \Af{tcam} additionally allows matching bits with an~unknown state. 

Since MAC lookup requires exact matches and as few memory accesses as possible for efficiency reasons, using binary \as{cam} seems to be a~promising solution. \Al{tcam} is, on the~other hand, commonly used for \as{ipprot} routing table lookup~\cite{cam, tcam-lpm, hash-ip-lookup-scalable-bloom} performed in \as{l3} switches (mentioned in section \ref{ss:osi}), as it allows for multiple matching.\footnote{The queried \as{ipprot} address can match to multiple \as{ipprot} routing table entries with different network prefixes. In order to distinguish between results produced by \as{tcam} and choose the~longest prefix match, entries stored in \as{tcam} must be appropriately sorted.}

Nonetheless, \as{cam} has serious drawbacks. Each individual memory bit in a~fully parallel \as{cam} must have its own associated comparison circuit. Consequently, the~physical size and manufacturing cost of the~memory chip increase in comparison to \as{ram} memory with the~same capacity~\cite{cam, flashlook}. Moreover, \as{cam} devices consume large amounts of power~\cite{cam, flashlook}.

There are some approaches that emulate the~function of \as{cam} using a~\as{ram} memory together with a~finite-state machine as its control logic~\cite{tcam-bram, tcam-scalable-ram, cam-xilinx}. In comparison to \as{cam}, those solutions provide lower cost and equally beneficial $O(1)$ lookup performance but require longer update time. Moreover, they result in inefficient resource usage.

All things considered, using \as{cam} may be justified only in applications where a~required lookup table size is relatively small, and high-performance is valued much more than cost and power consumption. Small \as{cam} is sometimes used, if at all, as an~overflow buffer \cite{fht-bloom, flashlook, one-move}.

\section{Tree-Based Solutions}
\label{tree-based}

\subsection{Binary Tree}
\label{binary-tree}

\noindent A~binary search tree is a~data structure that can be used to implement an~associative array and, thus, to locate a~specific key from within a~set. The~algorithm looks up a~key to get the~address of the~entire key-value pair, which is usually stored aside. These properties make tree-based solutions an~alternative for \as{mac} table lookup.

However, in order for a~data structure to function as a~binary search tree, its entries must be sorted in numerical order. On that condition, the~lookup algorithm, illustrated in figure \ref{fig:tree}, can be performed as follows~\cite[p. 88]{all-switch}:
\begin{itemize}
	\item The~searched key is equated with the~entry stored in the~middle of a~table (the~root node of a~tree). If it is a~match, a~lookup is done.
	\item Otherwise, the~searching is continued only in the~appropriate half of the~table (a~subtree), depending on whether the~searched key is less or greater than the~key in a~read entry.
	\item The~process is repeated until the~key is found or there is no remaining subtree.
\end{itemize}

\begin{figure}[h!]
	\centering
	\includegraphics[scale=1]{pic/binary-tree.pdf}
	\caption{The~concept of a~binary tree structure.}
	\label{fig:tree}
\end{figure}

It should be noticed that each operation implies that either the~key is found or that unsearched entries are reduced by one-half. In the~case of a~binary search tree, the~worst-case number of memory accesses required to perform a~complete search is $O(\log n)$, where $n$ is the~number of entries in a~table. Besides, entire memory resources intended for a~\as{mac} table may be filled with entries. Unlike for hash-based solutions, discussed in section \ref{hash-based}, it does not impact the~lookup process efficiency. 

Nonetheless, the~necessity of maintaining the~numerical order of entries in a~table is a~severe drawback of the~binary search tree algorithm. Each insertion requires re-sorting entries and updating even the~entire contents of the~table. It is a~critical issue for forwarding engine that must provide wire-speed requests processing. The~most common remedy for this problem is keeping shadow memory for a~lookup table and updating one copy of a~table while performing lookup operations using a~second copy~\cite[p. 89]{all-switch}. It results in doubling memory resources, though.

\subsection{Trie}
\label{trie}

\noindent Another tree-based approach that can be used for \as{mac} table implementation is a~bitwise trie data structure~\cite{optimizing-lookup}. In contrast to a~binary tree, nodes in a~trie are not associated with particular keys but with their prefixes. Thereby, a~root node is empty, all nodes in a~subtree have a~common prefix, and only some nodes store entire keys. While in the~case of numerical values such as \as{mac} addresses, individual nodes contain consecutive bits, a~trie can also be used to store chars that form strings, as depicted in figure \ref{fig:trie}.

\begin{figure}[h!]
	\centering
	\includegraphics[scale=0.75]{pic/trie.pdf}
	\caption{The~concept of a~trie structure.}
	\label{fig:trie}
\end{figure}

The structure is usually stored in memory as linked lists containing the~pointers to consecutive nodes, which contributes to memory overhead. The~worst-case search time depends on the~depth of a~trie, which is related to the~maximum key length. Besides, tries must be balanced to be efficient. 

Trie-based solutions have relatively poor performance in regard to handling exact matching of long values, like 48-bit \as{mac} address. 
Even with partitioning memory into separate blocks for different trie levels and reading them in a~pipeline, searching still requires multiple sequential memory accesses per each request. A~trie data structure is more suitable for matching with wildcards required in many network applications, for instance in a~firewall rule or in the~longest prefix match. Many variants of the~trie-based searching are used for \as{ipprot} lookup mechanisms in \as{l3} switches.

\section{Hash-Based Solutions}
\label{hash-based}

\noindent Definitely, the~most common solution for \as{l2} switch lookup table implementation is a~hash-based structure \cite{effect, ultra-fast}. In general, a~hash table is a~data~structure used to store data~in an~associative manner -- references to stored objects are made on the~basis of the~key mapped to the~object. A~chosen hash function is used to calculate a~hash array index for the~associated key-value pair, as depicted in figure \ref{fig:hash-basic}.

In the~simplest implementation, each key stored in a~hash array has its unique index value, so the~insert, delete and search operations are performed in a~constant time, which is convenient for the~hardware implementation of a~switch Filtering Database.

\begin{figure}[h!]
	\centering
	\includegraphics[scale=1]{pic/hash-basic.pdf}
	\caption{The~concept of a~hash table structure.}
	\label{fig:hash-basic}
\end{figure}

\subsection{Hash Collisions}
\label{hash-collisions}

\noindent The~major weakness of hash tables is the~possibility of the~hash collision when different keys are supposed to be mapped to the~same hash index. The~applied collision resolution policy significantly impacts the~memory usage along with worst-case and average times for insert, delete and search operations. The~probability of collision is inversely proportional to the~number of hash indexes. However, the~challenge is to combine efficiency with reasonable table size. Besides, in terms of hardware implementation, it is valuable to ensure deterministic operations time, possibly independent of a~load of a~table -- any operation which does not complete in some fixed amount of time complicates pipeline architecture and logic control. 

Hash collisions correlate closely with the~decreased hash table capacity. The~experimental tests with the~use of random \as{mac} addresses and six off-the-shelf switch devices from different vendors \cite{effect} demonstrate that inability to store some \as{mac} addresses and thus frames flooding starts when a~table is only 12\% full on average. The~same research shows that the~mean number of not stored addresses, while attempting to learn the~number of random addresses that do not exceed a~theoretical table capacity, is not negligible, as submitted in figure \ref{fig:flooded}. Examined devices are distinguished with $M$x$K$ labels, which means that the~hash table in a~given device has $M$ possible hash values, and up to $K$ keys may be mapped to each value. It should be noted that the~parameters of D and E switches differ significantly, as depicted in figure \ref{fig:flooded}, despite the~same hash table structure. It appears that those devices vary in the~hash function used, which has a~substantial impact on the~parameters of the~table for a~given set of stored keys.

\begin{figure}[h!]
	\centering
	\includesvg[scale=0.25]{pic/flooded}
	\caption{Number of flooded addresses for given number of network addresses and hash table sizes for experiment with six off-the-shelf switch devices. \textit{Source:} based on~\cite{effect}.}
	\label{fig:flooded}
\end{figure}

In some cases, a~hash function can be optimized for the~expected key values. Particularly, if all possible key values are known in advance, there can be matched a~perfect hash function, which guarantees to map elements of a~set to a~set of integers with no collisions. Under that condition, the~lookup time is $O(1)$, and the~keys do not need to be stored in a~table.

Nevertheless, if keys are likely to change at runtime, there is a~nonzero probability of~hash collisions, and the~method of handling them must be chosen. The~figure \ref{fig:birthday-problem} presents the~probability of collision for a~16-bit hash function, according to the~formula~\cite{birthday-problem}:
\begin{equation}
\label{eq:birthday-problem}
P(n,m) \approx 1 - e^{-n(n-1)/(2m)}
\end{equation}
where $m$ is the~number of possible hash index values (in this example $2^{16}$), and $n$ is the~number of random \as{mac} addresses supposed to be stored in a~hash table\footnote{In probability theory the~problem of collisions is generally known as \textit{the birthday problem}. The~formula \ref{eq:birthday-problem} is a~Taylor approximation of the~calculated probability~\cite{birthday-problem}.}. The~formula \ref{eq:birthday-problem} is used on the~assumption that a~hash function is perfectly random and $n \ll m$.

\begin{figure}[h!]
	\centering
	\includesvg[scale=0.25]{pic/birthday-problem}
	\caption{The probability of collision for a~16-bit hash function.}
	\label{fig:birthday-problem}
\end{figure}

The~most straightforward collision resolution algorithm is to replace an~existing key in the~table with a~new one or ignore the~new one. However, in \as{lan} switching devices that solution might be insufficient. Even if it concerned only two \as{mac} addresses with a~hash collision in a~network and the~rest of a~lookup table would be empty, one of those addresses could not be stored. As explained in section \ref{required-lookup-table-size}, it results in an~excess load on a~network and inefficient bandwidth usage.

The~collision resolution techniques described in the~literature are included in the~following sections, along with the~analysis of their impact on the~\as{l2} switch lookup table performance and implementation.

\subsection{Parallel Hashing}
\label{parallel-hashing}

\noindent The~Parallel hashing takes advantage of the~power of multiple choices for key location within an~entire hash table. The~idea was broadly studied~\cite{two-choices, balanced-allocations, multilevel}, and the~obtained results suggest that the~number of collisions can be significantly reduced even with just two random choices. 

The most straightforward application is storing in memory multiple hash tables ${T_{1},..., T_{d}}$ with corresponding $d$ independent hash functions and placing a~key into $T_{i+1}$ in the~case of collision in ${T_{i}}$. The~benefits may be derived when implementation allows the~parallelization of hash function computations and the~parallelization of memory accesses to separate memory banks. To achieve higher memory utilization, the~hash tables are usually not equal in size, but their sizes follow a~decreasing geometric sequence -- the~number of buckets in $i$th sub-table is $m_{i} = m_{i+1} \cdot r$, where $r$ is a~fixed proportion between subsequent sub-tables~\cite{multilevel, peacock}. Thus, a~hash function assigned to $i$th sub-table must be in range $\{0, m_{i}-1\}$. The probability of unresolved collision is the product of collision probabilities for each sub-table.

Even though this approach is not commonly used on its own, the~concept is widely employed as an~extension to Chaining (\ref{chaining}) and Open Addressing (\ref{open-addressing}) hash collision resolution methods.

\subsection{Adaptive Hashing}
\label{adaptive-hashing}

\noindent The~adaptive hashing is based on recalculating hash values in the~case of collision. The~strategy provides a~constant lookup time and reduces the~probability of unresolved collision (when all methods of rehashing keys stored in a~table also result in hash collisions) to $P_{adaptive} = P^{t}$~\cite{ultra-fast}, where $P$ is a~probability of collision for a~hash table with single hash function used, and $t$ is the~number of available different ways of hash values calculation.

However, adaptive hashing disadvantage is the~necessity of refilling a~hash table after finding a~collision. It is especially not effective for network applications with frequent changes in routing tables. Besides, the~necessity to move already stored key during insertion entails either unavailability of forwarding engine for the~time of insertion processing or using a~shadow memory, which duplicates the~required memory resources. It should also be noted that for hardware implementation of a~forwarding engine all range of hash functions must be implemented, thus increasing the~usage of logic resources.

% NOTE
% \cite{flashlook}
% A~method used for IP lookup. Hash table is partitioned by means of index bits and a~rehashing is performed within the~scope of single partitions to provide more uniform distribution (parallel hashing + adaptive hashing). 
% Section VI-A shows that HashTune reduces the~number of overflows 98% compared to the~single hash function case, and the~on-chip memory requirement to a~quarter of the~single hash function case.

Therefore, the~method is usually used only as complementary to other hash collision resolution methods. The~rehashing often is performed as a~last resort, when despite using other hash collision resolution strategies, the~unresolved further collision occurs. Some architectures allow avoiding all-at-once rehashing. For instance, in the~case of the~parallel hashing, only a~few last sub-tables may be rehashed~\cite{multilevel, peacock}. 

Alternatively, rehashing is done dynamically to optimize the~uniformity of entries distribution, thus to prevent from unresolved collisions in the~future~\cite{flashlook, one-move}. Kirsch and Mitzenmacher~\cite{one-move} proved that it is possible to significantly increase the~memory utilization of multiple-choice hashing schemes by allowing at most one key to be moved during an~insertion.

\subsection{Chaining}
\label{chaining}

\noindent The~common method of resolving hash collisions is to store entries with the~same assigned hash value (and thus the~same hash array index) in some kind of list, called a~bucket. Each bucket is independent. In order to locate an~entry, a~corresponded list of bucket slots is scanned until either the~matching search key or an~empty slot is found. This strategy, known as separate chaining, is illustrated in figure \ref{fig:hash-separate-chaining}.

\begin{figure}[h!]
	\centering
	\includegraphics[scale=1]{pic/hash-separate-chaining.pdf}
	\caption{Hash collision resolved by a~separate chaining.}
	\label{fig:hash-separate-chaining}
\end{figure}

% NOTE
% Big-O is an~inclusive upper bound, while little-o is a~strict upper bound.

Assuming that a~bucket data structure is a~linear list and it is searched sequentially, the~average and the~worst-case query time are not deterministic and depend on a~load of a~table. In the~worst-case scenario, the~lookup time is $O(n)$, where $n$ is the~number of entries stored in a~hash table. However, a~sequential allocation of $n$ keys to $n$ buckets results in, with high probability, ${(1+o(1))\log n / \log \log n}$ maximum lookup time~\cite{asymmetry-load-balancing}. An~average cost for successful search when $n$ keys are stored in $m$ buckets is ${1 + (n-1)/2m}$~\cite{aoc}. Additionally, a~maximum lookup time may be reduced using other data structure instead of a~linear list at the~cost of increased implementation complexity. For example, a~binary search tree, described in section \ref{binary-tree}, provides $O(\log n)$ worst-case search time. An~approach usually used to restrain high deviations from the~median search time is defining the~upper bound on the~number of entries that may be put to a~single bucket. 

In hardware implementations the~memory space for slots in a~bucket usually is pre-allocated. Then all slots for a~given hash index may be read and compared to the~incoming key in parallel~\cite{gigabit-switch} to achieve a~deterministic lookup time $O(1)$ and an~increased throughput. Therefore, the~limitation in the~number of slots per bucket is closely correlated with memory parameters. If a~thoroughly parallel reading is not possible, some sequential processing must be applied, which is a~trade-off between required memory bandwidth and a~worst-case search time.

The opposite strategy for hardware implementation is a~linked list with pointers to subsequent bucket slots. Its main advantage is higher memory utilization as slots do not have to be assigned to specific buckets in advance. On the~other hand, the~pointers cause the~memory overhead, and the~searching must be done sequentially. Both concepts of separate chaining hardware implementation are compared in figure \ref{fig:hash-chaining-impl}, pre-allocation as the~case (a) and linked list as the~case (b).

% bandwidth - bytes per second, it depends on memory interface data signal width, clock frequency, number of memory interfaces and number of data transfers per clock (double data rate)

\begin{figure}[h]
	\centering
	\includegraphics[scale=1.35]{pic/hash-separate-chaining-impl.pdf}
	\vspace{-4mm}
	\caption{Hardware implementation strategies for a~separate chaining.}
	\label{fig:hash-chaining-impl}
\end{figure}

Insert and delete operations require memory access to a~single slot. Deleting an~entry from a~table may be handled by moving keys with the~same assigned hash index to provide a~proper lookup sequence. An~alternative is to put a~special value, not allowed for legitimate keys, to the~slot that contained the~deleted key. While lookup the~marked slot is skipped, and during insertion it may be overwritten.

In the~case of reading a~linear list of slots sequentially, a~\textit{load factor} is calculated to determine the~trade-off between average lookup time and memory space cost. A~load factor is defined as:
\begin{equation}
\label{eq:load-factor}
\alpha = \frac{n}{m}
\end{equation}
where $n$ is the~number of keys stored in the~table and $m$ is the~number of buckets~\cite{aoc}. This average number of entries per bucket must be relatively low to keep the~average search time acceptable. However, as the~load factor approaches 0, there is not necessarily any reduction in search cost. 

% TODO \cite{segmented-hash} wzory?

The~separate chaining method does not eliminate the~problem of the~potential inability to store another MAC address due to hash collisions, despite the~remaining empty slots in a~table. However, it reduces the~probability of occurrence of that problem to an~acceptable value. The~probability of unresolved hash collisions may be evaluated with the~equation~\cite{ultra-fast}:
\begin{equation}
P = 1 - \frac{\lambda^{mk}_{rl}(rl)!(m - rl)!}{m!}
\end{equation}
where $\lambda^{mk}_{rl}$ is given by:
\begin{equation}
\lambda^{mk}_{rl} = \displaystyle\sum^{\begin{bmatrix}\frac{m}{k}\end{bmatrix}}_{s = max(0; m-r(k-1))} C^{s}_{r}{(C^{k}_{l})}^{s} \lambda^{m-ks, k-1}_{r-s, l}
\end{equation}
and $rl$ is the~number of possible node addresses ($2^{48}$ for Ethernet \as{mac} addresses), $r$ is the~number of possible hash values, $m$ is the~number of nodes in networks connected by a~switch, $k$ is the~number of slots per bucket and expression $C^{m}_{n} = \frac{n!}{m!(n-m)!}$ determines the~number of $m$-combination of a~set $n$. The~figure \ref{fig:hash-collisions-slots} illustrates the~results for different values of $k$ parameter. In general, if the~uniformity of a~hash function is sufficient, a~maximum of a~few slots per bucket usually is the~optimal solution.

% TODO przerobic na wlasny wykres
% TODO jaka tu byla przyjeta wartosc r?
\begin{figure}[H]
	\centering
	\includegraphics[scale=0.3]{pic/hash-collisions-slots.png}
	\caption{Collision probability for separate chaining method. \textit{Source:}~\cite{ultra-fast}.}
	\label{fig:hash-collisions-slots}
\end{figure}

\subsubsection{2-way Chaining}

\noindent The~chaining strategy variants base on the~idea of using multiple hash functions. It aims to reduce the~expected maximum bucket load and to achieve higher memory utilization. Azar, Broder, Karlin, and Upfal~\cite{balanced-allocations} proposed a~hashing algorithm called a~2-way chaining, where two uncorrelated hash functions are used to calculate two hash indexes for a~given key. The~key is inserted into the~bucket that contains fewer entries at the~time of the~insertion. Effective lookup is performed by searching two buckets in alternate order. The~provided analysis~\cite{balanced-allocations} indicates that sequential allocation of $n$ keys to $n$ buckets with a~2-way chaining schema results in, with high probability, $2 \log \log n/\log 2 + \theta(1)$ maximum lookup time. Thus, providing two choices causes an~exponential decrease of the~maximum bucket load in comparison to the~conventional separate chaining method. Moreover, such an~approach affords a~more uniform distribution of the~load across buckets~\cite{multiple-hash-ip-lookup}. An~average lookup time for successful search when $n$ keys are stored in $m$ buckets is $\leq 2 + (n-1)/m$~\cite{balanced-allocations}, which is no more than twice the~average access time for separate chaining with a~single hash function used. 

\subsubsection{d-random Hashing}

\noindent The~concept can be generalized to using $d \geq 2$ hash functions to calculate alternative hash indexes for keys supposed to be store in a~table. Then, after sequentially putting $n$ keys into $m$ buckets with the~use of $d$ hash functions, and assuming that $n \ge m$, a~maximum lookup time is ${2(1 + o(1)) \log \log n / \log d + \theta(n/m)}$ (with high probability)~\cite{balanced-allocations}. In literature~\cite{multiple-hash-ip-lookup}, the~strategy is addressed as d-random hashing. However, it should be noticed that the~difference in lookup performance between using $d$ and $d+1$ hash functions, where $d \geq 2$, is lesser than between using single and two hash functions.

\subsubsection{d-left Hashing}

\noindent V\"{o}cking~\cite{asymmetry-load-balancing} studied the~scenario where the~choice between $d$ possible hash indexes for a~key is, in contrast to d-random hashing, not uniform. The~idea comprises splitting a~hash table with $m$ buckets into $d$ sub-tables $T_{1}, T_{2}, ... T_{d}$  of equal size $m/d$ (assuming that $m$ is divisible by $d$) and using $d$ hash functions with a~range of $[1, m/d]$. A~key $k$ is inserted into a~sub-table with least entries in an~appropriate bucket ($T_{1}[h_{1}(k)]$ / $T_{2}[h_{2}(k)]$ / ... / $T_{d}[h_{d}(k)]$). What is important, in the~case of a~tie a~key is always inserted into a~leftmost sub-table. It was proven~\cite{asymmetry-load-balancing} that after sequentially putting $n$ keys into $n$ buckets a~maximum bucket load is ${\log \log n/(d \log\phi_{d}) + O(1)}$, where $\phi_{d}$ corresponds to the~exponent of growth for a~generalized Fibonacci sequence and is defined as ${\phi_{d} = \lim_{k\to\infty}\sqrt[k]{F_{d}(k)}}$ and ${F_{d}(k) = 0}$ for ${k \leq 0}$, ${F_{d}(1) = 1}$ and ${F_{d}(k)=\sum^{d}_{i=1}F_{d}(k-i)}$ for ${k \geq 2}$. In general, ${\phi_{2} < \phi_{3} < \phi_{4} ... < 2}$ and ${\phi_{d} > 2^{(d-1)/d}}$. The~strategy described above was called d-left hashing~\cite{multiple-hash-ip-lookup}.

%\begin{equation}
%\log_{2}x = \frac{\log x}{\log 2}
%\end{equation}
%\begin{equation}
%\frac{\log(\log n)}{d\log \phi_{d}} = \frac{\log 2}{d\log \phi_{d}} \cdot \log_{2}(\log n)
%\end{equation}

A~d-left hashing provides the~improvement in the~distribution of the~load over d-random hashing, as ${\log \log n / (d\log \phi_{d}) < \log \log n / \log d }$~\cite{asymmetry-load-balancing}. For example, with two sub-tables of size $n/2$, the~most collisions is, with high probability, ${0.69... \log_{2} \log n + O(1)}$ in comparison to ${\log_{2} \log n + O(1)}$ for d-random hashing. Except for higher memory utilization, a~d-left hashing allows for performing lookups for each of $d$ buckets in parallel, as sub-tables may be stored in memory independently. Another strategy is to pipeline memory lookups, which allows to slightly improve the~overall throughput -- as the~leftmost sub-tables are more likely to store more keys, they can be searched first. When a~key is found, other sub-tables need not be searched. A~d-left~hashing was proven to be beneficial for \as{ipprot} lookup~\cite{multiple-hash-ip-lookup}. 

%\subsubsection{Coalesced Hashing}

% Coalesced hashing, also called coalesced chaining, is a~strategy of collision resolution in a~hash table that forms a~hybrid of separate chaining and open addressing. It uses the~concept of Open Addressing(linear probing) to find first empty place for colliding element from the~bottom of the~hash table and the~concept of Separate Chaining to link the~colliding elements to each other through pointers. 

\subsection{Open Addressing}
\label{open-addressing}

\noindent Another hash collision resolution strategy is called open addressing. In this method, hash table buckets contain only a~single slot, and the~hash function result for a~given key does not determine the~location of an~entry in memory. When a~new entry is supposed to be inserted into a~table, an~empty bucket is searched, starting from the~address corresponding to the~calculated hash index. The~searching proceeds in some probe sequence until an~unused bucket is found. The~lookup operation is performed similarly -- the~buckets are probed in the~same sequence until either the~searched key or an~unoccupied bucket is found. Hence, although the~time for insertion and lookup is low on average, in the~worst-case scenario, it may be $O(n)$ -- proportional to the~number of entries stored in a~table. 

% TODO 
% wiki - wykres load factor a~separate chaining / open addressing - zaleznie od probe sequence, pewnie dla linear

As for separate chaining, average and worst-case lookup time are not deterministic, and a~load factor (explained in section \ref{hash-collisions}) has a~significant impact on lookup performance. On the~contrary, using open addressing hash collision resolution method imposes additional restrictions on the~hash function. Besides uniformity, the~function should also provide the~minimalisation of clustering of hash values that are consecutive in the~probe order, while for separate chaining hash table buckets are completely independent. 

\subsubsection{Linear Probing}

\noindent The~simplest probe sequence in open addressing method is a~linear probing, in which the~interval $l$ between probes is fixed, usually 1. Hence, the~$i$th position in the~bucket sequence for value $k$ and hash table with $m$ buckets is $h(i, k) = (h(k) + i \cdot l) \bmod m$. The~expected cost of insertion is ${(1+1/(1-\alpha)^{2})/2}$, where $\alpha$ is a~load factor~\cite{cuckoo}. With constant $\alpha < 1$, the~expected maximum lookup time is $\Omega(\log n)$~\cite{cuckoo}. 

\subsubsection{Double Hashing}

\noindent Another well-known probe sequence is called a~double hashing. One hash function is used to calculate a~primary hash index, and a~second hash function is used to determine an~interval between subsequent probes. The~$i$th position in the~bucket for key $k$ and hash table with $m$ buckets is calculated as $h(i, k) = (h_{1}(k) + i \cdot h_{2}(k)) \bmod m$. Hash functions must be random, uniform and independent, $h_{1}$ is selected to have a~range $\{0, m-1\}$, and $h_{2}$ to have a~range $\{1, m-1\}$. The~interval depends on the~hashed key what minimizes the~effect of clustering. The~expected number of probes during insertion is ${1/(1-\alpha)}$~\cite{cuckoo}. With constant $\alpha < 1$, the~expected maximum successful lookup time is $\Omega(\log n)$~\cite{cuckoo}. 

\subsubsection{Cuckoo Hashing}

\noindent The~open addressing variant used commonly to implement exact matching in networking applications is a~Cuckoo hashing~\cite{cuckoo, emoma, parallel-d-pipeline}. For instance, it is used for packet processing in \af{sdn}\footnote{The \al{sdn} is an~architecture that aims in providing flexible and programmable network, which is easy to manage. Its main postulate is the~centralization of the~network management by disassociating the~control plane from the~data forwarding function. The~control plane consists of one or more controllers, which are the~core elements of an~SDN architecture. They manage network devices using the~OpenFlow protocol and data flow tables, and also determines the~routing of packets.} controllers~\cite{sdn}. 

According to the~original definition by Pagh and Rodler~\cite{cuckoo}, a~Cuckoo hash table is made of two sub-tables, $T_{1}$ and $T_{2}$, equal in size. Independent hash functions $h_{1}$, $h_{2}$ are used to calculate hash indexes for a~given key $k$ in each of sub-tables. Every key is stored either in bucket ${T_{1}[h_{1}(k)]}$ or in bucket ${T_{2}[h_{2}(k)]}$, never in both. The~key is inserted into ${T_{1}[h_{1}(k)]}$ bucket if it is unoccupied. Otherwise, the~key $k$ is inserted anyway, but the~key $k_{r}$ removed from the~bucket is supposed to be inserted into an~appropriate bucket in a~second sub-table (${T_{2}[h_{2}(k_{r})]}$), and so forth. Thus, the~insertion of a~new key may implicate a~series of moves in a~Cuckoo hash table. 

If the~process loops and it is infeasible to store all entries in sub-tables, keys must be rehashed with the~use of other hash function. However, for uniform hash functions, $m$ buckets in each sub-table and $n$ keys stored in a~table, where ${m \ge (1+\varepsilon)n}$, ${\varepsilon > 0}$, the~probability that rehashing is a~necessity is $O(1/n)$~\cite{cuckoo}. The~examples of insert operation are illustrated in figure \ref{fig:cuckoo} -- in case (a) a~key is successfully inserted, although it requires two additional moves, and in case (b) a~key cannot be inserted without rehashing. 

\begin{figure}[h!]
	\centering
	\includegraphics[scale=1]{pic/cuckoo.pdf}
	\caption{The examples of insert operation for Cuckoo hashing. \textit{Source:}~\cite{cuckoo}.}
	\label{fig:cuckoo}
\end{figure}

The theoretical worst-case number of iterations is not bounded by a~constant, but is correlated with the number of entries in a table. There is a non-negligible probability that some insertions will require $\Omega(\log n)$ moves. However, the~expected complexity of an~insertion is $O(1+1/\varepsilon)$ if $m = 2n(1+\varepsilon)$, where $m$ is the~number of buckets in both tables and $n$ is the~number of keys meant to be stored in a~Cuckoo hash table~\cite{cuckoo}. Moreover, the~number of permissible moves during insertion can be constrained.

The~Cuckoo hashing is an~efficient option for switch forwarding table hardware implementations due to constant worst-case lookup time. Besides, it is distinguished by high memory utilization ($O(n)$), and reading from sub-tables can be done in parallel. The~Cuckoo hashing is particularly suitable for applications where the~expected ratio of lookups to insertions is high. 

\subsubsection{d-ary Hashing}

\noindent The~d-ary hashing is the~generalization of the~Cuckoo hashing concept, with a~hash table divided into $d \ge 2$ sub-tables. It uses $d$ hash functions and key $k$ may be placed in one of $d$ sub-tables in positions ${h_{1}(k), h_{2}(k), ..., h_{d}(k)}$~\cite{worst-case-constant}. During insertion the~key is placed randomly in any of all unoccupied locations.

The idea is similar to d-left hashing presented in section \ref{chaining}. The~main difference is in the~algorithm behaviour when all buckets ${h_{1}(k), h_{2}(k), ..., h_{d}(k)}$ are already occupied. For d-left~hashing the~key cannot be inserted, what is a~limitation in terms of memory utilization, while for d-ary hashing the~entries are moved to alternative locations to store a~new key in a~table. The~experiments \cite{worst-case-constant, parallel-d-pipeline} confirm that before rehashing is a~necessity, the~available memory space for storing keys is filled in approximately 50\% for $d=2$, 91\% for $d=3$, 97\% for $d=4$ and 99\% for $d=5$. 

If $d$ alternative locations for a~given $k$ are supposed to be checked sequentially, the~ordered insertion should be applied -- the~new key is to be placed in the~first, not any free location. Such an~approach provides a~lower average lookup time as entries are concentrated on the~leftmost sub-tables and, thus, found faster.

Fotakis, Pagh et al. \cite{worst-case-constant} proved that using d-ary hashing schema $n$ keys may be stored in $(1+\varepsilon)n$ buckets for $\varepsilon>0$ with a~constant amortized lookup time $O(\log(1/\varepsilon))$. The~example of $d=4$ choices suffices for $\varepsilon \approx 0.03$. 

%\subsubsection{Filter Hashing}

%\noindent Filter Hashing is an~alternative to d-ary Hashing that uses polynomial hash function of degree $O(\sqrt{d})$~\cite{worst-case-constant}. It results in $d = O(\log \log (1-\varepsilon))$ worst-case number of required memory accesses for a~lookup operation.

\section{Maximizing the~Throughput}
\label{maximizing-throughput}

\noindent The~solutions described in the~previous section are often combined to optimize a~forwarding engine implementation. The~novel research particularly concerns improving the~performance by providing determinism and reducing the~average number of memory accesses. The~latter is especially relevant for architectures with Filtering Database stored in off-chip memory with limited bandwidth.

One area of research is using a~space-efficient data~structure holding information about the~estimated lookup table contents as support for membership queries, which is compact enough to be stored in on-chip memory. Verifying this structure first avoids searching a~lookup table in the~worst-case scenario -- when a~key is not present in a~table.
It reduces the~average number of main memory accesses for a~single lookup query, thereby improving the~performance.
An example of such a~structure, which has found widespread use in network applications, is a~Bloom filter~\cite{bloom-count, fht-bloom}. The~theory of Bloom filters, and the~overall architectures that make use of them, are presented in the~following sections.

\subsubsection{Bloom Filter}
\label{bloom-filter}

\noindent The~simple binary Bloom filter is a~bit array of $m$ bits, initialized to zero. The~filter is also parameterized by a~constant $k$ that defines the~number of independent hash functions, $h_1, h_2,...,h_k$, each with range $\{1,...,m\}$, generating a~uniform random distribution.
When inserting an~element $e$ into a~table, its value is an~input for each of the~$k$ hash functions, and the~results correspond to the~positions of set filter bits.  The~idea is illustrated in figure \ref{fig:bloom} with the~example of a~Bloom filter with eight bits ($m = 8$) and three hash functions ($k = 3$). 

\begin{figure}[h!]
	\centering
	\includegraphics[scale=1]{pic/bloom.pdf}
	\caption{The example of setting Bloom filter bits when inserting element.}
	\label{fig:bloom}
\end{figure}

When querying for an~element to verify if it is present in a~table, hashes $h_1(e),...,h_k(e)$ are calculated to get $k$ array positions. If any of the~bits in these positions are not set, an~element is definitely not in a~table. However, if all those bits are set, only then an~element is considered to be in a~table -- the~slight shortcoming of the~Bloom filter method is the~nonzero probability of false positive error. It means that the~filter may indicate that the~searched key is present in the~table when in fact, it is not. Thus, the~Bloom filter may be regarded as a~compact but approximate representation of the~table's elements. In the~context of an~\as{l2} switch forwarding engine, this is not a~significant problem - after all, if it were not for the~use of a~filter, searching would be necessary anyway. What is more important, for a~given, static data~set represented by a~Bloom filter structure, false negatives are not possible~\cite{bloom-count}. 

The~drawback of a~conventional Bloom filter is the~inability to update an~array adequately while removing elements from a~table -- there is no way to determine which of the~$k$ bits should not be cleared as it may correspond to other table elements as well. Clearing all $k$ bits would introduce the~possibility of false negatives.

The~probability of a~false positive, after inserting $n$ keys into an~array of $m$ bits, with the~use of $k$ hash functions, can be calculated as~\cite{bloom-summary}:  

\begin{equation}
\label{eq:bloom-false-positive}
\varepsilon \approx {(1 - e^{-kn/m})}^k
\end{equation}

The~value of $\varepsilon$ increases with the~number of elements inserted into a~set. Therefore, to keep the~probability of a~false positive at a~reasonable level, the~number of elements in a~set should be limited. Assuming usage of an~optimal value of $k$ that minimizes the~false positive probability~\cite{bloom-summary}: $k = \frac{m}{n}ln2$ (and putting aside the~fact that the~number of hash functions must be a~positive integer), the~maximum $n$ for a~given $\varepsilon$ is obtained by~\cite{bloom-scalable}:

\begin{equation}
\label{eq:bloom-max-elements}
n \approx -\frac{m(ln2)^2}{ln\varepsilon}
\end{equation}

Hence, the~optimal number of bits per element equals $1.44log_{2}1/\varepsilon$. 
Table \ref{t:bloom} presents an~example set of required sizes~of Bloom filter for representing MAC table in the~\as{l2} switch for a~given maximum number~of nodes in a~network and accepted probability of a~false positive.

\begin{table}[h!]
	\centering
	\small
	\caption{Example parameters of Bloom filter for representing MAC table.}
	\label{t:bloom}
	\begin{tabular}{m{0.5\textwidth}|
			>{\centering\arraybackslash}m{0.12\textwidth}|
			>{\centering\arraybackslash}m{0.12\textwidth}|
			>{\centering\arraybackslash}m{0.12\textwidth}||}
		\cline{2-4}
		& \multicolumn{3}{c||}{\textbf{accepted false positive probability}} \\ 
		\cline{2-4}
		& 0.1\% & 0.01\% & 0.001\% \\ 
		\hline
		\multicolumn{1}{||l|}{\textbf{maximum number of nodes in network}} & 1000 & 1000 & 1000  \\ \hline
		\multicolumn{1}{||l|}{\textbf{required Bloom filter size [B]}} & 1794 & 2392 & 2990  \\ \hline
		\multicolumn{1}{||l|}{\textbf{optimal number of hash functions}} & 10 & 13 & 17  \\ \hline
	\end{tabular}
\end{table}

There are Bloom filter variants that address the~conventional filter's shortcomings -- false positive errors and inability to delete elements from a~data~set. The~counting Bloom filter \cite{bloom-summary, fht-bloom} extends the~binary Bloom filter by replacing each bit in the~filter with a~counter. It allows for implementing a~deletion operation on a~set. If an~item is added to a~set, the~appropriate counter is incremented, and when it is deleted, the~counter is decremented.
%\footnote{Further work on counting Bloom filter~\cite{bloom-count} focuses on potential false negative errors caused by an~incorrect item deletion when a~data~set is not stored together with counting Bloom filter structure. The~example use case are network applications that require real-time processing of large amounts of data, like intrusion detection systems.} 
The~common Bloom filter version used to decrease the~problem of false positive errors is, in turn, the~scalable Bloom filter~\cite{bloom-scalable, bloom}. It is made up of a~series of $k$ conventional Bloom filters with a~hash function assigned to each of them. Thereby each element of a~set is always represented by exactly $k$ bits, which enhances the~filter's robustness.

% Bloomier filter
% To overcome the~false positive problem, Bloomier filters have been
% introduced. These rely on multiple Bloom filters to provide a~deterministic way
% of matching several keys to the~same value. The~main reason why Bloomier
% filters are not useful in implementing a~large hash table for caches is that the
% set of values has to be much smaller than the~set of keys for this scheme to work.

In the~case of Bloom filters, time needed either to add items or to check membership is constant ($O(k)$) -- it is independent of the~number of items already in the~set. However, it should be emphasized that the~Bloom filter data~structure does not store actual data~values, and a~separate solution must be provided for primary database storage. Besides, it does not reduce the~time needed to perform a~single search when a~key is indicated as present in a~database. 

Nevertheless, Bloom filters structures kept in embedded memory may be useful, especially if primary database lookups are time-consuming and there are expected many queries for keys that are not in a~table. In conclusion, maintaining a~Bloom filter representation of MAC table contents may improve throughput at the~cost of additional resources and the~increase of~a~programmable logic design complexity.

\subsubsection{Fast Hash Table}
\label{fast-hash-table}

\noindent The~\af{fht}~\cite{fht-bloom} combines d-random hashing concept and counting Bloom filter used to eliminate the~necessity to search multiple buckets. In general, the~\as{fht} structure consists of a~hash table with $m$ buckets and an~array with associated $m$ counters. Each key has assigned $d$ hash indexes calculated with the~use of $d$ independent hash functions with a~range $[0, m-1]$.

% NOTE
% FHT: In the~case of collisions for d hash functions and key k, <d counters are incremented and key is placed into <d buckets.	
% FHT: In the~case of a~tie in counter values, counter with smaller index is chosen.
In \af{bfht} variant insertion implies incrementing up to $d$ counters and placing a~key into up to $d$ buckets. In the~case of lookup operation bucket with the~lowest value of the~corresponding counter (except zeroes) is searched. Deletion comprises decrementing counters and removing a~key from appropriate buckets.  

It should be emphasized that the~support for exact matches is not restricted to pointing whether the~entry is or is not in a~hash table, but also impacts the~performance of successful lookups. The~analysis and simulations performed in~\cite{fht-bloom} indicate the~significant improvement in the~expected maximum bucket load and average lookup time in comparison to separate chaining not supported by a~filter. The~increase in performance is proportional to the~number of hash functions used, but at the~cost of maintaining $d$ copies of each key in main memory (except for on-chip memory needed for a~filter) and $d$ times more memory accesses during insertion and deletion. The~\as{bfht} drawbacks are addressed by \af{pfht} and \af{sfht} variants.

% NOTE
% Pruning procedure relies on counters values, so the~order of pruning for subsequent keys does not matter.
% It should be additionally optimized to keep exactly one item in each non-empty bucket - it eases the~pruning procedure. 
% In \cite{fht-bloom} it is proved that the~same number of hash functions as for Bloom filter is also optimal for the~FHT's lookup performance.
In \as{pfht}, a~key~is stored in only a~single bucket, related to the~counter with the~lowest value. Thus, a~counter value for a~given bucket no longer reflects the~number of keys actually stored in it. The~lookup time for \as{pfht} will always be shorter than or equal to the~\as{bfht}~\cite{fht-bloom}. The~difficulty of this method is to guarantee that a~searched key is always contained in a~bucket pointed by the~lowest value of a~counter -- thus, during insertion and deletion of a~given key, the~location of other keys stored in a~table must be reconsidered, what is called a~pruning procedure. What is more, processing a~deletion also requires maintaining a~\as{bfht} table before pruning, which can be kept in software that is responsible for updates. The~algorithm for the~pruning procedure is presented in~\cite{fht-bloom}. The~average number of memory accesses is $O(1+2dn/m)$ for insertion and $O(4nd^{2}/m)$ for deletion\footnote{Assuming the~optimal Bloom filter ($d = mln2/n$), the~average memory accesses is $1+ 2ln2 = 2.44$ for insertion and $4dln2 = 2.8d$ for deletion.}. It is accepted as long as insertions and deletions are rare and non-critical in comparison to lookups and there is a~possibility to additionally maintain a~\as{bfht} table.

The simplified variant of such solution, EMOMA~\cite{emoma}, is based on Cuckoo hash table and resolves the problem of undetermined state of a~hash table during insertion procedure with the usage of additional on-chip memory structure to store entries that are pending insertion or that have failed insertion. On lookup, the stashed items are checked in the first instance.

% NOTE
% SHT insertion complexity $O(nd^2/m + d)$ \cite{fht-bloom}
% SHT deletion complexity?
Another idea used in \as{sfht} is to use a~linked list data structure for entries in a~bucket and to allow the~multiple buckets to share the~same key stored in memory using pointers. The~counter values may not reflect the~length of the~linked list associated with a~bucket, but it is guaranteed that a~key will be found after probing the~number of slots equal to the~associated counter value. Nevertheless, to satisfy this condition, a~key must be sometimes duplicated in a~linked list. It causes the~memory requirement to be up to three times more than for regular hash table or \as{pfht}~\cite{fht-bloom}.

\subsubsection{Segmented Hash Table}
\label{segmented-hash-table}

% NOTE
% Only one hash function is used for all segments of the~Segmented Hash Table.
% Either Separate Chaining or Open Addressing may be used for resolving hash collisions within a~single segment, but it impacts the~probabilistic filter usage -- for open addressing it is a~bit mask pointing to unoccupied slots (buckets?) in a~given segment and for linear chaining it is a~counting Bloom filter.

\noindent The~main contribution of the~\af{sht}~\cite{segmented-hash} is reducing the~average number of memory accesses in comparison to \as{fht} for a~given number of on-chip filter bits per hash table entry and a~given probability of successful search\footnote{The probability of successful search is the~percentage of traffic used for a~test for which there was an~entry in a~hash table.}.

The~\al{sht} consists of a~hash table with $m$ buckets, divided into $d$ segments, and the~$d$ independent Bloom filters maintained in on-chip memory separately for each segment. The~key is inserted into segment with the~least loaded bucket. The~crucial to this architecture is a~tie resolution -- the~segment is chosen according to the~selective filter insertion algorithm~\cite{segmented-hash}. The~key idea behind that schema is to minimize the~number of nonzero counters in each Bloom filter while keeping the~segments uniformly balanced as the~false positive rate grows with the~percentage of nonzero counters. Thereby, the~selective filter insertion algorithm reduces the~size of the~Bloom filter data structure for a~given false positive rate target.

\subsubsection{Peacock Hashing}

\noindent The~Peacock hashing, proposed by Kumar, Turner and Crowley~\cite{peacock}, aims at providing the~same level of determinism in lookup performance as in \as{sht} and \as{fht} architectures, but even less on-chip memory required. In Peacock hashing the hash table structure and operations are the same as for the parallel hashing, but additionally there are on-chip Bloom filters which maintain an approximate summary of the entries present in sub-tables.

The crucial benefit of Peacock hashing is that Bloom filter is not used for the~largest table $T_{1}$, which holds at least half of all buckets. For each lookup, filters are verified and only backup sub-tables with a positive result are probed. If it turns out to be false positive and the searched key is not present in backup sub-tables, or if there is no positive result for any backup sub-table, the main table $T_{1}$ is probed. If false positives are rare, with high probability only a single memory access per query is required~\cite{peacock}.

A ratio between subsequent sub-tables determines the trade-off between Bloom filters and hash table memory resources requirements. Large ratio results in low hash table memory utilization, but provides a reduced on-chip filter size.

%A High Throughput Parallel Hash Table on FPGA
%using XOR-based Memory

%We achieve this by implementing novel XOR based multi-ported
%block memories on FPGAs. Additionally, we develop a technique
%to optimize the memory requirement of the hash table if the ratio
%of search to insert/update/delete queries is known beforehand.

%design is scalable to 16 PEs and supports throughput up to 5926
%MOPS. It matches the throughput of the state-of-the-art hash
%table design – FASTHash, which only supports search and insert
%operations. Comparing with the best FPGA design that supports
%the same set of operations, our hash table achieves up to 12.3×
%speedup.

%Several works have focused on increasing the throughput of
%hash table implementations by “parallelizing” i.e. by exploiting certain features of the hash table, such as the availability of multiple partitions [11]. - d pipeline
%However, the parallelism that can
%be obtained using such approaches is highly data dependent
%and the worst case performance - for example, when all
%queries belong to the same partition - is similar to a serial
%implementation

% about FASTHash
%In [12], we developed a hash table that supports p queries
%(p > 1) in each clock cycle, where p is the number of parallel
%Processing Engines (PEs), even in the worst case. In other
%words, the performance of the hash table is agnostic to the
%data. Such a guarantee was obtained by making the assumption
%that the application using the hash table requires only search
%and insert operations
%In this work, we address the limitations of [12] by completely redesigning the hash table to support all hash table
%operations - search, insert, update and delete

% flashlook
%In [13], the authors
%proposed a hash table based IP lookup technique that achieves
%a lookup throughput of 250 Mops/s. 

%An fpga implementation of high-throughput
%key-value store using bloom filter
%Authors in [14] developed a hash table implementation using bloom filter which reduces
%unnecessary hash table accesses. 

% d pipeline
%In [11], the authors developed a
%Cuckoo hash table with multiple parallel pipelines with each
%pipeline having a different entry point.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%\cite Maximizing the Throughput of Hash Tables in Network Devices with Combined SRAM/DRAM Memory

%\subsubsection{Parallel d-Pipeline}
%\label{parallel-d-pipeline}

% parallel d-pipeline
%The continuous increase in speed and
%complexity of networking devices creates a~need for higher throughput exact
%matching in many applications. In this paper, a~new Cuckoo hashing
%implementation named parallel d-pipeline is proposed to increase throughput. The
%scheme presented is targeted to implementations in which the tables are accessed
%in parallel.


%\cite{multiple-hash-ip-lookup}
%a natural goal is to ensure that the number of
%items that fall in a~bucket corresponds to the capacity of a~single
%cache line, so that each hash bucket corresponds to a~cache line
%of memory. This ensures that each level examined during the
%binary search only requires a~single memory access

%\cite{parallel-d-pipeline}

% TODO czy technika parallel d-pipeline nadaje sie tylko do cuckoo hashing czy tez do innych przypadkow (jakich)?

%Ciekawy i przydatny (pozwalajacy zwiekszyc przepustowosc) algorytm do wykorzystania w sytuacji wielu odczytow 
%z roznych obszarow pamieci w ramach przetwarzania jednego zapytania.
%
%In ASIC/FPGA implementations and for small-medium tables,
%an embedded memory per table can be easily used so that tables
%are accessed in parallel to further speed up access.
%Then the worst case access time is fixed and given by just one memory access.
%
%However, as discussed in the following, in many
%networking applications, most searches are successful.

%As mentioned before, the d tables can be stored in one or several
%memories. In the first case, tables are accessed serially and in the
%second case in parallel. For the serial access, the worst case access
%time occurs when the element is not stored in the tables or it is
%found in the last table. In both cases, d memory accesses are
%needed. The average number of accesses will be lower and
%depends on the table occupancy and on the strategy used for insertion. As with d-left hashing, ordered insertion provides a~lower
%average access time as items are concentrated on the first tables
%and therefore found faster.

%In the parallel case, there are d memories such that each table is
%stored in a~different memory and search operations can be done by
%accessing all memories in parallel. In that case, all searches require
%d accesses and are completed in one memory cycle. Alternatively,
%search operations can be pipelined to reduce the number of memory accesses. In the pipeline architecture, a~search operation
%accesses each of the memories sequentially such that when the current operation moves to access the second memory, the next search
%operation can access the first memory. Therefore the performance
%in terms of throughput is the same as that of parallel searches.
%However, in the pipeline architecture once a~search is successful,
%the rest of the memories do not have to be accessed. 

%Therefore, the
%average number of accesses is reduced to that of the serial case.
%Due to the pipeline, all the search operations are completed in d
%memory cycles.

% zestawienie rysunkow:
% serial
% parallel
% parallel pipeline
% parallel d-pipeline
% + opis do nich o co chodzi z kolorami kwadratow

% parallel pipeline implementation
%In this architecture, an incoming element is searched in table one in the first cycle. If the element is not found, then it is
%searched in table two and so on. As soon as the element is found,
%no further searches are done and the element is just propagated
%through the pipeline until it reaches the output.

% parallel d-pipeline implementation
%The proposed technique to optimize the throughput of Cuckoo
%hashing implementations is based on a~simple observation: in the
%parallel pipeline implementation, the tables are not accessed in all
%cycles. For example, in a~parallel pipeline implementation if an element is found in Table 1, then on the following cycles Tables 2,3,. . .,
%d are not accessed.
%Therefore, throughput can potentially be increased with implementations that make use of all the tables in all the cycles.

% opis jak dokladnie dziala algorytm

%For the traditional pipeline implementation shown in Fig. 1, the
%throughput is constant and equals one element per cycle. This is
%not the case for the new parallel d-pipeline scheme (or for the serial
%scheme) in which throughput depends on several factors. The first
%one is the percentage of the matching operations that are successful. This is because an operation that fails requires accesses to all
%d tables and leaves no room for improvement. On the other hand, a
%successful operation may require less than d accesses leaving some
%cycles to be used by other operations. The second factor is whether
%ordered or random insertion is used in the Cuckoo hashing. Finally
%and related to the second factor, the occupancy of the tables also
%affects the throughput.

% zzalozeniem ze table occupancy is close to 100 percent i sa wykorzystywane 4 tabele cuckoo hashing
%Since in the proposed
%implementation the four tables are accessed in all cycles the average throughput per cycle will be approximately 4/2.5 ? 1.6. This
%means a~60 percent increase over the traditional pipeline implementation that provides a~throughput of 1.0. 
%
%The traditional systems (both standard and pipeline) have a
%throughput of 1.0 and therefore are able to process up to
%156.25 million of packets per seconds. Supposing a~minimum
%packet size of 40 bytes the maximum throughput sustainable
%under worst case packet size conditions is 50 Gbps. Instead, since
%the proposed parallel d-pipeline can be clocked at the same frequency as the traditional parallel pipeline implementation, but
%processes an average number of 1.6 packets per cycle, the
%maximum throughput can be estimated as 80 Gbps. Therefore, for
%a given FPGA technology, the packet throughput can be increased
%significantly. This clearly illustrates the benefits of the proposed
%scheme. The main disadvantage of the scheme is that it requires
%some additional FPGA resources.

%In this paper, an architecture to increase the throughput of Cuckoo
%hashing implementations has been proposed and evaluated. The
%scheme is targeted to high-speed parallel implementations and
%modifies the existing pipeline architecture to ensure that all tables
%are accessed in all cycles. This is done by introducing one pipeline
%per table such that elements can enter the system at any given
%table. This enables a~more efficient use of the tables and therefore
%an increase in throughput.

%The overheads in the FPGA implementation are less than
%5 percent in the case study. This increase in FPGA resource usage
%is clearly offset by the gains in throughput.

%The proposed architecture could also be potentially used to
%speed up parallel implementations of other multiple hash schemes
%such as d-left hashing and Bloom filters [18]. This can be an attractive topic for future work.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% comparison

%\cite{aoc} str 545

% TODO rozroznic zlozonosc time complexity dla softu zarzadzajacego zawartoscia tablicy a~hardwarem, ktory z niej korzysta

%\cite{cuckoo}
%porownanie na wykresach: cuckoo, 2-way, separate, linear probing

% power
% resource utilization
% latency
% limitations
% performance
% update time
% lookup time
% average lookup time
% worst-case lookup time
% insert time
% delete time
% memory used
% space
% memory bandwith required 

% bloom - time - $O(k)$
%\cite{hash-ip-lookup-scalable-bloom} % tabelki, wykresy z porównaniem
%\cite{optimizing-lookup}

